////////////////////////////////////////////////////
//// 0.0.1 Initial
//// 0.0.2 Adds basic write of GEDCOMFILE -> very simple
//// 0.0.3 Adds Birthdate to all.
////       Adds BirthPlace to main individual.
////       Adds Death and Burial tags
////       Adds initial Error feedback.
//// 0.1.0 Adds occupation and education to main indi.
////       Adds 'New' data function.
////       Fixes close window error
////       Fixes deathdate error
//// 0.1.1 Adds HTML Report button.
////       Adds Show Image button
////       Adds load Image button
////       New Graphics
////       Adds tag 0 TRLR 
////       Adds tag 1 DEST
//// 0.1.2 fixes hang of report.
////
//// Written by Michael Gibson
//// Under the GPL
////
//// Creates Initial GEDCOM FILE
////////////////////////////////////////////////////
#include <stdio.h>
#include <gtk/gtk.h>

gchar *r_version="0.1.2";

GtkWidget *window;
GtkWidget *file_text;
GtkWidget *text_02, // 0001 Given Name [First [Middle]]
          *text_03, // 0001 Surname    [Last|Maidan   ]
          *text_04, // 0001 Gender     [M F           ]
          *text_05, // 0001 Birth Date [DD MMM YYYY   ]
          *text_06, // 0001 Birth Place
          *text_07, // 0001 Death Date [DD MMM YYYY   ]
          *text_08, // 0001 Death Place
          *bl_text, // 0001 Burial Location
          *text_address,
          *text_09, // 0001 Occupation
          *text_10, // 0001 Education
// text_11 not used (for growth)
// text_12 not used (for growth)
          *text_13, //0002 Given Name 
          *text_14, //0003 Given Name
          *text_15, //0002 Surname
          *text_16, //0003 Surname
          *text_17, //0002 Birth Date
          *text_18; //0003 Birth Date
// text_19 not used (for growth)
// text_20 not used (for growth)

gchar *error_msg;

gchar *filename="family.ged";

////////////////////////
//// name file
////////////////////////
void name_file (GtkWidget *widget, gpointer data) {
                                                                                                                             
   GtkWidget *dialog, *label;
   dialog = gtk_dialog_new_with_buttons ("Name File", window, GTK_DIALOG_DESTROY_WITH_PARENT,
                                         GTK_STOCK_OK, GTK_RESPONSE_NONE, NULL);
   label = gtk_label_new ("Save as the following GEDCOM file:\n\n");

   file_text=gtk_entry_new(); 
   printf("%s filename",filename);
   gtk_entry_set_text (GTK_ENTRY (file_text), "filename.ged");
   /* Ensure that the dialog box is destroyed when the user responds. */
                                                                                                                             
   g_signal_connect_swapped (GTK_OBJECT (dialog), "response", G_CALLBACK (gtk_widget_destroy), GTK_OBJECT (dialog));
                                                                                                                             
   /* Add the label, and show everything we've added to the dialog. */
                                                                                                                             
   gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label);
   gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), file_text);
   gtk_widget_show_all (dialog);
}

////////////////////////////////////
//// load report module
///////////////////////////////////
void l_report(void){

   char systemstring[50];

   sprintf(systemstring,"./gtkgedreport %s &",filename);

   system(systemstring);

}

////////////////////////
//// error message
////////////////////////
void quick_message(void) {

   GtkWidget *dialog, *label;
   dialog = gtk_dialog_new_with_buttons ("Help", window, GTK_DIALOG_DESTROY_WITH_PARENT,
                                         GTK_STOCK_OK, GTK_RESPONSE_NONE, NULL);
   label = gtk_label_new (error_msg);
   
   /* Ensure that the dialog box is destroyed when the user responds. */
   
   g_signal_connect_swapped (GTK_OBJECT (dialog), "response", G_CALLBACK (gtk_widget_destroy), GTK_OBJECT (dialog));

   /* Add the label, and show everything we've added to the dialog. */

   gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label);
   gtk_widget_show_all (dialog);
}

//////////////////////
/// write data
/////////////////////
static void writedata(GtkWidget *widget, gpointer data)
{
  FILE *fp;

  const gchar *givenname1;
  const gchar *surname1;
  const gchar *gender1;
  const gchar *birthday1;
  const gchar *birthplac1;
  const gchar *deathdate1;
  const gchar *deathplac1;
  const gchar *burialplac1;
  const gchar *occupation1;
  const gchar *education1;

  const gchar *givenname2;
  const gchar *surname2;
  const gchar *birthday2;

  const gchar *givenname3;
  const gchar *surname3;
  const gchar *birthday3;

  printf("*** %s filename\n",filename);
  filename =  gtk_entry_get_text (GTK_ENTRY (file_text));
  printf("*** %s filename\n",filename);

  givenname1 = gtk_entry_get_text (GTK_ENTRY (text_02));
  surname1   = gtk_entry_get_text (GTK_ENTRY (text_03));
  gender1    = gtk_entry_get_text (GTK_ENTRY (text_04));
  birthday1  = gtk_entry_get_text (GTK_ENTRY (text_05));
  birthplac1 = gtk_entry_get_text (GTK_ENTRY (text_06));
  deathdate1 = gtk_entry_get_text (GTK_ENTRY (text_07));
  deathplac1 = gtk_entry_get_text (GTK_ENTRY (text_08));
  burialplac1= gtk_entry_get_text (GTK_ENTRY (bl_text));
  occupation1= gtk_entry_get_text (GTK_ENTRY (text_09));
  education1 = gtk_entry_get_text (GTK_ENTRY (text_10));

  givenname2 = gtk_entry_get_text (GTK_ENTRY (text_13));
  surname2   = gtk_entry_get_text (GTK_ENTRY (text_15));
  birthday2  = gtk_entry_get_text (GTK_ENTRY (text_17)); 

  givenname3 = gtk_entry_get_text (GTK_ENTRY (text_14));
  surname3   = gtk_entry_get_text (GTK_ENTRY (text_16));
  birthday3  = gtk_entry_get_text (GTK_ENTRY (text_18));

  fp=fopen("temp.ged","w+");

/// Heading
  fprintf(fp,"0 HEAD \n");
  fprintf(fp,"1 SOUR MRGIBSON.COM\n");
  fprintf(fp,"2 VERS %s\n",r_version);
  fprintf(fp,"2 NAME FirstData\n");
  fprintf(fp,"1 DEST ANSTFILE"); 
  fprintf(fp,"1 CHAR ANSI \n");
  fprintf(fp,"1 FILE %s \n",filename);
  fprintf(fp,"1 GEDC \n");
  fprintf(fp,"2 VERS 5.5 \n");
  fprintf(fp,"2 FORM LINEAGE-LINKED \n");

/// individual 1
  fprintf(fp,"0 @I0001@ INDI\n");

  if(surname1[0]!='\0') fprintf(fp,"1 NAME %s /%s/\n",givenname1,surname1);
  else{
     error_msg = "Could not write Name of ID '0001'.\nYou must enter a Surname. \nThis is a person's Last or Maiden name.";
     quick_message();
  }

  if(gender1[0]=='F' || gender1[0]=='M') fprintf(fp,"1 SEX %1s\n",gender1);
  else{
     error_msg = "Could not write Gender/Sex of ID '0001'.\nValid entries are:\nM for Male.\nF for Female.";
     quick_message();
  }

  if(surname1[0]!='\0') fprintf(fp,"1 BIRT\n");

  if(birthday1[0] >= 47 && birthday1[0]<= 56) fprintf(fp,"2 DATE %s\n",birthday1);
  else{
     if(birthday1[0] != '\0'){
       error_msg = "Could not write Birth Date of ID '0001'.\nValid format is: DD MMM YYYY\nExample: 10 Jan 1905";
       quick_message();
     }
  }

  if(surname1[0]!='\0' && birthplac1 != '\0') fprintf(fp,"2 PLAC %s\n",birthplac1);
  if(surname1[0]!='\0' && deathdate1 != '\0') fprintf(fp,"1 DEAT Y\n");
  if(surname1[0]!='\0' && deathdate1 != '\0') fprintf(fp,"2 DATE %s\n",deathdate1);
  if(surname1[0]!='\0' && deathplac1 != '\0') fprintf(fp,"2 PLAC %s\n",deathplac1);
  if(surname1[0]!='\0' && burialplac1!= '\0') fprintf(fp,"1 BURI\n");
  if(surname1[0]!='\0' && burialplac1!= '\0') fprintf(fp,"2 PLAC %s\n",burialplac1);

  if(surname1[0]!='\0' && occupation1 != '\0') fprintf(fp,"1 OCCU %s\n",occupation1);
  if(surname1[0]!='\0' && education1 != '\0') fprintf(fp,"1 EDUC %s\n",education1);

  if(surname1[0]!='\0') fprintf(fp,"1 FAMC @F0001@\n");

/// individual 2
  fprintf(fp,"0 @I0002@ INDI\n");
  if(surname2[0]!='\0') fprintf(fp,"1 NAME %s /%s/\n",givenname2,surname2);
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp,"1 SEX M \n");
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp,"1 BIRT \n");  
  if(birthday2[0] >= 47 && birthday2[0]<= 56) fprintf(fp,"2 DATE %s\n",birthday2);
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp,"1 FAMS @F0001@\n");

/// individual 3
  fprintf(fp,"0 @I0003@ INDI\n");
  if(surname3[0]!='\0') fprintf(fp,"1 NAME %s /%s/ \n",givenname3,surname3);
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp,"1 SEX F \n");
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp,"1 BIRT \n");
  if(birthday3[0] >= 47 && birthday3[0]<= 56) fprintf(fp,"2 DATE %s\n",birthday3);
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp,"1 FAMS @F0001@\n");

/// family
  fprintf(fp,"0 @F0001@ FAM\n");
  if(surname2[0]!='\0' || givenname2[0]!='\0') fprintf(fp,"1 HUSB @I0002@\n");
  if(surname3[0]!='\0' || givenname3[0]!='\0') fprintf(fp,"1 WIFE @I0003@\n");
  if(surname1[0]!='\0') fprintf(fp,"1 CHIL @I0001@\n"); 

  fprintf(fp,"0 TRLR\n");

  fclose(fp);

}
static void do_exit_notify(GtkWidget *widget, gpointer data)
{
    g_print ("Exit\n");
}


/* Another callback */
static void destroy( GtkWidget *widget, gpointer   data )
{
    gtk_main_quit ();
}
/////////////////////////////////////
/// Clear Data
////////////////////////////////////

static void cleardata(GtkWidget *widget, gpointer data)
{
  gtk_entry_set_text (GTK_ENTRY (text_02), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_03), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_04), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_05), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_06), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_07), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_08), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_09), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_10), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_13), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_14), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_15), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_16), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_17), "\0");
  gtk_entry_set_text (GTK_ENTRY (text_18), "\0");
  gtk_entry_set_text (GTK_ENTRY (bl_text), "\0");

}
///////////////////////////////////////
/// Main
////////////////////////////////////////
int main(int argc, char *argv[])
{
    GtkWidget *bbox1, *bbox2, *bbox3, *bbox4, *bbox5, *bbox6;
    GtkWidget *id_label_01, *id_label_02, *id_label_03, *id_text_01, *id_text_02, *id_text_03;
    GtkWidget *label;
    GtkWidget *image;
    GtkWidget *bl_label;
    GtkWidget *button_01, *button_02, *button_03, *button_04, *button_05;
    GtkWidget *load_image_button;
    GtkWidget *label_01,*label_02,*label_03,*label_04,*label_05,*label_06,*label_07,*label_08;
    GtkWidget *label_09,*label_10,*label_11,*label_12,*label_13,*label_14,*label_15,*label_16;
    GtkWidget *pre_pic;
    GtkWidget *label_address;
    GtkWidget *label_17,*label_18, *label_f2, *label_f3;
    GtkWidget *the_box,*box_01,*box_02,*box_03,*box_04,*box_05,*box_06,*box_07,*box_08,*box_09;
    GtkWidget *box_10,*box_11,*box_12,*box_13,*box_14,*box_15;

    gtk_init (&argc, &argv);
    
    /* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_rc_parse("gedtools.rc" );
    gtk_window_set_title (GTK_WINDOW (window), "Create New GEDCOM");
    gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
    //gtk_window_set_default_size(GTK_WINDOW (window), 770,570);
    gtk_window_set_default_size(GTK_WINDOW (window), 800,600);

    g_signal_connect (G_OBJECT (window), "do_exit_notify", G_CALLBACK (do_exit_notify), NULL);
    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (destroy), NULL);
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);

    /* create the widgets */
    the_box = gtk_vbox_new (FALSE, 5);
    box_01 = gtk_hbox_new (FALSE, 5);
    box_02 = gtk_hbox_new (FALSE, 5);
    box_03 = gtk_hbox_new (FALSE, 5);
    box_04 = gtk_hbox_new (FALSE, 5);
    box_05 = gtk_hbox_new (FALSE, 5);
    box_06 = gtk_hbox_new (FALSE, 5);
    box_07 = gtk_hbox_new (FALSE, 5);
    box_08 = gtk_hbox_new (FALSE, 5);
    box_09 = gtk_hbox_new (FALSE, 5);
    box_10 = gtk_hbox_new (FALSE, 5);
    box_11 = gtk_hbox_new (FALSE, 5);
    box_12 = gtk_hbox_new (FALSE, 5);
    box_13 = gtk_hbox_new (FALSE, 5);
    box_14 = gtk_hbox_new (FALSE, 5);
    box_15 = gtk_hbox_new (FALSE, 5);

    label_01 = gtk_image_new_from_file ("i.xpm");
    id_label_01=gtk_label_new("ID #  ");
        id_text_01=gtk_entry_new();
        gtk_entry_set_text (GTK_ENTRY (id_text_01), "0001");
        gtk_entry_set_editable(GTK_ENTRY (id_text_01),FALSE );
        gtk_entry_set_width_chars(GTK_ENTRY(id_text_01),5);
    label_02 = gtk_label_new("     Given Name"); 
        text_02=gtk_entry_new();
    label_03 = gtk_label_new("     Surname"); 
        text_03=gtk_entry_new();

    label_04 = gtk_label_new("Gender"); 
        text_04=gtk_entry_new(); 
        gtk_entry_set_width_chars(GTK_ENTRY(text_04),3);
        gtk_entry_set_max_length(GTK_ENTRY(text_04),1);

    label_05 = gtk_label_new("     Date of Birth"); 
        text_05=gtk_entry_new();
    label_06 = gtk_label_new("     Location of Birth"); 
        text_06=gtk_entry_new();

    label_07 = gtk_label_new("Date of Death "); 
        text_07=gtk_entry_new();
    label_08 = gtk_label_new("     Location of Death"); 
        text_08=gtk_entry_new();
    bl_label = gtk_label_new("Burial Location");
        bl_text = gtk_entry_new();

    label_address = gtk_label_new("Address");
        text_address=gtk_entry_new();

    pre_pic = gtk_image_new_from_file ("viewphoto.xpm");
    label_09 = gtk_label_new("Occupation"); 
        text_09=gtk_entry_new();
    label_10 = gtk_label_new("     Education"); 
        text_10=gtk_entry_new();

    label_11 = gtk_image_new_from_file("f.xpm");    
    label_12 = gtk_image_new_from_file("m.xpm");    

    label_13 = gtk_label_new("Given Name"); 
        text_13=gtk_entry_new();
    label_14 = gtk_label_new("Given Name"); 
        text_14=gtk_entry_new();

    id_label_02=gtk_label_new("            ID #                              ");
        id_text_02=gtk_entry_new();
        gtk_entry_set_text (GTK_ENTRY (id_text_02), "0002");
        gtk_entry_set_editable(GTK_ENTRY (id_text_02),FALSE );
        gtk_entry_set_width_chars(GTK_ENTRY(id_text_02),5);
    id_label_03=gtk_label_new("ID #                              ");
        id_text_03=gtk_entry_new();
        gtk_entry_set_text (GTK_ENTRY (id_text_03), "0003");
        gtk_entry_set_editable(GTK_ENTRY (id_text_03),FALSE );
        gtk_entry_set_width_chars(GTK_ENTRY(id_text_03),5);

    label_15 = gtk_label_new("     Surname"); text_15=gtk_entry_new();
    label_16 = gtk_label_new("Surname"); text_16=gtk_entry_new();

    label_17 = gtk_label_new("Date of Birth"); text_17=gtk_entry_new();
    label_18 = gtk_label_new("Date of Birth"); text_18=gtk_entry_new();

    label_f2 = gtk_image_new_from_file ("mi.xpm");
    label_f3 = gtk_image_new_from_file ("pi.xpm");

    button_01 = gtk_button_new();
      bbox1 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox1), 1);
      image = gtk_image_new_from_file ("close.xpm");
      label = gtk_label_new ("Close");
      gtk_box_pack_start (GTK_BOX (bbox1), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox1), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_01), bbox1);

    button_02 = gtk_button_new();
      bbox2 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox2), 1);
      image = gtk_image_new_from_file ("filenew.xpm");
      label = gtk_label_new ("Clear Fields");
      gtk_box_pack_start (GTK_BOX (bbox2), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox2), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_02), bbox2);

    button_03 = gtk_button_new();
      bbox3 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox3), 1);
      image = gtk_image_new_from_file ("filesave.xpm");
      label = gtk_label_new ("Save as");
      gtk_box_pack_start (GTK_BOX (bbox3), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox3), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_03), bbox3);

    button_04 = gtk_button_new();
      bbox4 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox4), 1);
      image = gtk_image_new_from_file ("hnew.xpm");
      label = gtk_label_new ("Create HTML");
      gtk_box_pack_start (GTK_BOX (bbox4), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox4), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_04), bbox4);

   button_05 = gtk_button_new();
      bbox5 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox4), 1);
      image = gtk_image_new_from_file ("photo.xpm");
      label = gtk_label_new ("View Photo");
      gtk_box_pack_start (GTK_BOX (bbox5), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox5), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_05), bbox5);

   load_image_button = gtk_button_new();
      bbox6 = gtk_hbox_new (FALSE , 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox4), 1);
      image = gtk_image_new_from_file ("photo.xpm");
      label = gtk_label_new ("Load Photo");
      gtk_box_pack_start (GTK_BOX (bbox6), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox6), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (load_image_button), bbox6);
/// Quit button call back 
    g_signal_connect (G_OBJECT (button_01), "clicked", G_CALLBACK (do_exit_notify), NULL);
    g_signal_connect_swapped (G_OBJECT (button_01), "clicked", G_CALLBACK (gtk_widget_destroy), G_OBJECT (window));

/// New button call back
    g_signal_connect (G_OBJECT (button_02), "clicked", G_CALLBACK (cleardata), NULL);
                                                                                                                             
/// Save button call back
    g_signal_connect (G_OBJECT (button_03), "clicked", G_CALLBACK (writedata), NULL);
    g_signal_connect (G_OBJECT (button_03), "clicked", G_CALLBACK (name_file), NULL);

/// Report button call back
    g_signal_connect (G_OBJECT (button_04), "clicked", G_CALLBACK (l_report), NULL);
 
    gtk_container_add (GTK_CONTAINER (window), the_box);
    gtk_container_add (GTK_CONTAINER (the_box), box_01);
    gtk_container_add (GTK_CONTAINER (the_box), box_02);
    gtk_container_add (GTK_CONTAINER (the_box), box_03);
    gtk_container_add (GTK_CONTAINER (the_box), box_04);
    gtk_container_add (GTK_CONTAINER (the_box), box_05);
    gtk_container_add (GTK_CONTAINER (the_box), box_06);
    gtk_container_add (GTK_CONTAINER (the_box), box_07);
    gtk_container_add (GTK_CONTAINER (the_box), box_08);
    gtk_container_add (GTK_CONTAINER (the_box), box_09);
    gtk_container_add (GTK_CONTAINER (the_box), box_10);
    gtk_container_add (GTK_CONTAINER (the_box), box_11);
    gtk_container_add (GTK_CONTAINER (the_box), box_12);
    gtk_container_add (GTK_CONTAINER (the_box), box_13);
    gtk_container_add (GTK_CONTAINER (the_box), box_14);
    gtk_container_add (GTK_CONTAINER (the_box), box_15); 

    gtk_box_pack_start(GTK_BOX (box_01), button_01,FALSE,FALSE,1); //close 
    gtk_box_pack_start(GTK_BOX (box_01), button_02,FALSE,FALSE,1); //new ```
    gtk_box_pack_start(GTK_BOX (box_01), button_03,FALSE,FALSE,1); //save  
    gtk_box_pack_start(GTK_BOX (box_01), button_04,FALSE,FALSE,1); //report
    gtk_box_pack_start(GTK_BOX (box_01), button_05,FALSE,FALSE,1); //photo

    gtk_box_pack_start(GTK_BOX(box_02),label_01,FALSE,FALSE,1); //I label

    gtk_box_pack_start(GTK_BOX(box_03), id_label_01,FALSE,FALSE,1); //id
      gtk_box_pack_start(GTK_BOX(box_03),id_text_01,FALSE,FALSE,1);    
    gtk_box_pack_start(GTK_BOX(box_03), label_02,FALSE,FALSE,1); //given name
      gtk_box_pack_start(GTK_BOX(box_03),text_02,FALSE,FALSE,1);
    gtk_box_pack_start(GTK_BOX(box_03),label_03,FALSE,FALSE,1);  //surname
      gtk_box_pack_start(GTK_BOX (box_03), text_03,FALSE,FALSE,1 );


    gtk_box_pack_start(GTK_BOX(box_04),label_04,FALSE,FALSE,1); //sex
      gtk_box_pack_start(GTK_BOX(box_04),text_04,FALSE,FALSE,1);
   gtk_box_pack_start(GTK_BOX(box_04), label_05,FALSE,FALSE,1); //born
      gtk_box_pack_start(GTK_BOX(box_04),text_05,FALSE,FALSE,1);
    gtk_box_pack_start(GTK_BOX (box_04), label_06,FALSE,FALSE,1);
      gtk_box_pack_start (GTK_BOX (box_04), text_06,FALSE,FALSE,1);

    gtk_box_pack_start(GTK_BOX(box_08), label_f2,FALSE,FALSE,1); //filler


    gtk_box_pack_start (GTK_BOX(box_09), label_07,FALSE,FALSE,1); //death
      gtk_box_pack_start (GTK_BOX (box_09), text_07,FALSE,FALSE,1);
    gtk_box_pack_start(GTK_BOX(box_09), label_08,FALSE,FALSE,1);
      gtk_box_pack_start (GTK_BOX (box_09), text_08,FALSE,FALSE,1);

    gtk_box_pack_start(GTK_BOX(box_10), bl_label,FALSE,FALSE,1);
      gtk_box_pack_start (GTK_BOX (box_10), bl_text,FALSE,FALSE,1);

    gtk_box_pack_start(GTK_BOX(box_05), label_f3,FALSE,FALSE,1); //filler

    gtk_box_pack_start(GTK_BOX (box_06), pre_pic,FALSE,FALSE,1); //Picture Preview
    gtk_box_pack_start(GTK_BOX (box_06), label_address,FALSE,FALSE,1); //address
      gtk_box_pack_start(GTK_BOX (box_06), text_address,FALSE,FALSE,1);


    gtk_box_pack_start(GTK_BOX (box_07), load_image_button,FALSE,FALSE,1);
    gtk_box_pack_start(GTK_BOX (box_07), label_09,FALSE,FALSE,1);//occupation
      gtk_box_pack_start(GTK_BOX (box_07), text_09,FALSE,FALSE,1);
    gtk_box_pack_start (GTK_BOX (box_07), label_10,FALSE,FALSE,1); //education
      gtk_box_pack_start (GTK_BOX (box_07), text_10,FALSE,FALSE,1);

    gtk_box_pack_start (GTK_BOX (box_11), label_11,FALSE,FALSE,1);//father l
    gtk_box_pack_end (GTK_BOX(box_11), label_12,FALSE,FALSE,1);   //mother l

    gtk_box_pack_start(GTK_BOX(box_12), id_label_02,FALSE,FALSE,1); //id
      gtk_box_pack_start(GTK_BOX(box_12),id_text_02,FALSE,FALSE,1);
      gtk_box_pack_end(GTK_BOX(box_12),id_text_03,FALSE,FALSE,1);
    gtk_box_pack_end(GTK_BOX(box_12), id_label_03,FALSE,FALSE,1); //id

    gtk_box_pack_start (GTK_BOX (box_13), label_13,FALSE,FALSE,1);
      gtk_box_pack_start (GTK_BOX (box_13), text_13,FALSE,FALSE,1);
      gtk_box_pack_end (GTK_BOX (box_13), text_14,FALSE,FALSE,1);
    gtk_box_pack_end (GTK_BOX (box_13), label_14,FALSE,FALSE,1);

    gtk_box_pack_start (GTK_BOX (box_14), label_15,FALSE,FALSE,1);
      gtk_box_pack_start (GTK_BOX (box_14), text_15,FALSE,FALSE,1);
      gtk_box_pack_end (GTK_BOX (box_14), text_16,FALSE,FALSE,1);
    gtk_box_pack_end (GTK_BOX (box_14), label_16,FALSE,FALSE,1);

    gtk_box_pack_start (GTK_BOX (box_15), label_17,FALSE,FALSE,1); //f dob
      gtk_box_pack_start (GTK_BOX (box_15), text_17,FALSE,FALSE,1);
      gtk_box_pack_end (GTK_BOX (box_15), text_18,FALSE,FALSE,1);
    gtk_box_pack_end (GTK_BOX (box_15), label_18,FALSE,FALSE,1);   //m dob

    gtk_widget_show(the_box);
    gtk_widget_show(box_01);
    gtk_widget_show(box_02); 
    gtk_widget_show(box_03);
    gtk_widget_show(box_04);
    gtk_widget_show(box_05);
    gtk_widget_show(box_06);
    gtk_widget_show(box_07);
    gtk_widget_show(box_08);
    gtk_widget_show(box_09);
    gtk_widget_show(box_10);
    gtk_widget_show(box_11);
    gtk_widget_show(box_12);
    gtk_widget_show(box_13);
    gtk_widget_show(box_14);
    gtk_widget_show(box_15);

    gtk_widget_show (label_f2);
    gtk_widget_show (label_f3);
    gtk_widget_show (pre_pic);
    gtk_widget_show (label_01);
    gtk_widget_show (id_label_01);gtk_widget_show(id_text_01);
    gtk_widget_show (id_label_02);gtk_widget_show(id_text_02);
    gtk_widget_show (id_label_03);gtk_widget_show(id_text_03);
    gtk_widget_show (label_02);gtk_widget_show(text_02);
    gtk_widget_show (label_03);gtk_widget_show(text_03);
    gtk_widget_show (label_04);gtk_widget_show(text_04);
    gtk_widget_show (label_05);gtk_widget_show(text_05);
    gtk_widget_show (label_06);gtk_widget_show(text_06);
    gtk_widget_show (label_07);gtk_widget_show(text_07);
    gtk_widget_show (label_08);gtk_widget_show(text_08);
    gtk_widget_show (label_address);gtk_widget_show(text_address);
    gtk_widget_show (label_09);gtk_widget_show(text_09);
    gtk_widget_show (label_10);gtk_widget_show(text_10);
    gtk_widget_show (label_11);
    gtk_widget_show (label_12);
    gtk_widget_show (label_13);gtk_widget_show(text_13);
    gtk_widget_show (label_14);gtk_widget_show(text_14);
    gtk_widget_show (label_15);gtk_widget_show(text_15);
    gtk_widget_show (label_16);gtk_widget_show(text_16);
    gtk_widget_show (label_17);gtk_widget_show(text_17);
    gtk_widget_show (label_18);gtk_widget_show(text_18);
    gtk_widget_show (bl_label);gtk_widget_show(bl_text);
    gtk_widget_show (button_01);
    gtk_widget_show (button_02);
    gtk_widget_show (button_03);
    gtk_widget_show (button_04);
    gtk_widget_show (button_05);
    gtk_widget_show (load_image_button);
    gtk_widget_show (bbox1);
    gtk_widget_show (bbox2);
    gtk_widget_show (bbox3);
    gtk_widget_show (bbox4);
    gtk_widget_show (bbox5);
    gtk_widget_show (bbox6);
    gtk_widget_show (window);
    gtk_main ();
    return 0;
}
