////////////////////////////////////////////////////////
//// Gtk Front end for Mr.Gibson's GEDCOM Report
//// 0.0.1 Initail Release with Surname report
//// 0.0.2 Arg File Load
////       Versioning
////       completed message
//// 0.0.3 Option to show 1st 5 lines of head in GEDCOM
//// 0.1.0 vary messages 
////       Better format of head
//// 0.1.1 True Button Bar
////       New icons
////
//// Written by Michael Gibson
//// This is GPLed Software
///////////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>

char *r_version="0.1.1";

gchar gedfile[50];
gchar head1[50],
      head2[50],
      head3[50],
      head4[50],
      head5[50];
gchar *message;

GtkWidget *window;
GtkWidget *hlabel1, *hlabel2, *hlabel3, *hlabel4, *hlabel5;

///////////////////////////////////
//// read head of file
//////////////////////////////////
void read_head(void){

  FILE *fp;
  int x;

  printf("start head read\n");
  fp=fopen(gedfile,"r");

  fgets(head1,50,fp);
  fgets(head2,50,fp);
  fgets(head3,50,fp);
  fgets(head4,50,fp);
  fgets(head5,50,fp);

  for(x=0;x<50;x++){
    if(head1[x]=='\0' || head1[x]=='\r' || head1[x]=='\n'){
       head1[x]= ' ';
    }
    if(head2[x]=='\0' || head2[x]=='\r' || head2[x]=='\n'){
       head2[x]= ' ';
    }
    if(head3[x]=='\0' || head3[x]=='\r' || head3[x]=='\n'){
       head3[x]= ' ';
    }
    if(head4[x]=='\0' || head4[x]=='\r' || head4[x]=='\n'){
       head4[x]= ' ';
    }
    if(head5[x]=='\0' || head5[x]=='\r' || head5[x]=='\n'){
       head5[x]= ' ';
    }
  }

  fclose(fp);
  printf("end head read\n");
}



////////////////////////
//// done message
////////////////////////
void done_message(void) {
                                                                                                                                              
   GtkWidget *dialog, *label;
   dialog = gtk_dialog_new_with_buttons ("done", window, GTK_DIALOG_DESTROY_WITH_PARENT,
                                         GTK_STOCK_OK, GTK_RESPONSE_NONE, NULL);
   label = gtk_label_new (message);
                                                                                                                                              
   /* Ensure that the dialog box is destroyed when the user responds. */
                                                                                                                                              
   g_signal_connect_swapped (GTK_OBJECT (dialog), "response", G_CALLBACK (gtk_widget_destroy), GTK_OBJECT (dialog));
                                                                                                                                              
   /* Add the label, and show everything we've added to the dialog. */
                                                                                                                                              
   gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label);
   gtk_widget_show_all (dialog);
}


////////////////////////////////////////////////////////////
//// surname_report 
///////////////////////////////////////////////////////////
static void surname_report( GtkWidget *widget, gpointer   data )
{
  char systemcall[80];
  sprintf(systemcall,"./gedreport2 -s %s > %s.sn.html",gedfile,gedfile);
  system(systemcall);
  message = "\n\nThe surname report is now completed.     \n\n";
  done_message();
} 

////////////////////////////////////////////////////////////
//// INDI report 
////////////////////////////////////////////////////////////
static void indi_report( GtkWidget *widget, gpointer   data )
{
  char systemcall[80];
  sprintf(systemcall,"./gedreport2 -i %s > %s.in.html",gedfile,gedfile);
  system(systemcall);
  message="\n\nThe individuals report is now completed. \n\n";
  done_message();
}

/////////////////////////////////////////////////////////////
//// Family report 
////////////////////////////////////////////////////////////
static void fam_report( GtkWidget *widget, gpointer   data )
{
  char systemcall[80];
  sprintf(systemcall,"./gedreport2 -f %s > %s.fam.html",gedfile,gedfile);
  system(systemcall);
  message="\n\nThe family report is now completed.  \n\n";
  done_message();
}

/////////////////////////////////////////////////////
///// quit app
///////////////////////////////////////////////////// 
static void destroy( GtkWidget *widget, gpointer   data )
{
    gtk_main_quit ();
}


////////////////////////////////////////////////////
//// main
////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
  GtkWidget *bbox1, *bbox3, *bbox4, *bbox5;
  GtkWidget *file_label;
  GtkWidget *image, *label, *linelabel;
  GtkWidget *button_01, *button_03, *button_04, *button_05; //family report

  GtkWidget *the_box,*box_01,*box_02, *box_03;
  int show_head=0;
  char option;


  gtk_init (&argc, &argv);

  if(argc==2||argc==3){
    sprintf(gedfile,"%s",argv[1]);
    printf("%s = filename\n",gedfile);
  }
  else{
    sprintf(gedfile,"temp.ged");
    printf("%s = filename\n",gedfile);
  }

  if(argc==3){
    if(argv[2][0]=='-'){
      option=argv[2][1];
    }
  }

  if(option=='h'){
      show_head=1;
      printf("show head is on\n");
      read_head();
  }
  else{
      printf("show head is off\n");
  }

  

    /* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_rc_parse("gedtools.rc" );
    gtk_window_set_title (GTK_WINDOW (window), "GEDCOM Report");
    gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
    
    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (destroy), NULL);
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);

    /* create the widgets */
    the_box = gtk_vbox_new (FALSE, 5);
    //box_01 = gtk_hbox_new (FALSE, 5);
    box_01 = gtk_hbutton_box_new();
    box_02 = gtk_hbox_new (FALSE, 5);
    box_03 = gtk_vbox_new (FALSE, 0);

    file_label = gtk_label_new(gedfile);

    if(show_head==1){
      linelabel=gtk_label_new("Head");

      hlabel1=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(hlabel1),head1);
        gtk_editable_set_editable(hlabel1,FALSE); 

      hlabel2=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(hlabel2),head2);
        gtk_editable_set_editable(hlabel2,FALSE);

      hlabel3=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(hlabel3),head3);
        gtk_editable_set_editable(hlabel3,FALSE);

      hlabel4=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(hlabel4),head4);
        gtk_editable_set_editable(hlabel4,FALSE);

      hlabel5=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(hlabel5),head5);
        gtk_editable_set_editable(hlabel5,FALSE);

    }

    button_01 = gtk_button_new();
      bbox1 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox1), 1);
      image = gtk_image_new_from_file ("close.xpm");
      label = gtk_label_new ("Close");
      gtk_box_pack_start (GTK_BOX (bbox1), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox1), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_01), bbox1);

    button_03 = gtk_button_new();
      bbox3 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox3), 1);
      image = gtk_image_new_from_file ("sn.xpm");
      label = gtk_label_new ("HTML");
      gtk_box_pack_start (GTK_BOX (bbox3), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox3), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_03), bbox3);

   button_04 = gtk_button_new();
      bbox4 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox4), 1);
      image = gtk_image_new_from_file ("ind.xpm");
      label = gtk_label_new ("HTML");
      gtk_box_pack_start (GTK_BOX (bbox4), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox4), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_04), bbox4);

   button_05 = gtk_button_new();
      bbox5 = gtk_vbox_new (FALSE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (bbox5), 1);
      image = gtk_image_new_from_file ("fam.xpm");
      label = gtk_label_new ("HTML");
      gtk_box_pack_start (GTK_BOX (bbox5), image, FALSE, FALSE, 1);
      gtk_box_pack_start (GTK_BOX (bbox5), label, FALSE, FALSE, 1);
      gtk_widget_show (image);
      gtk_widget_show (label);
      gtk_container_add (GTK_CONTAINER (button_05), bbox5);


    g_signal_connect_swapped (G_OBJECT (button_01), "clicked", G_CALLBACK (gtk_widget_destroy), G_OBJECT (window));

    g_signal_connect (G_OBJECT (button_03), "clicked", G_CALLBACK (surname_report), NULL);
    g_signal_connect (G_OBJECT (button_04), "clicked", G_CALLBACK (indi_report), NULL);
    g_signal_connect (G_OBJECT (button_04), "clicked", G_CALLBACK (fam_report), NULL);
    

    gtk_container_add (GTK_CONTAINER (window), the_box);
    gtk_container_add (GTK_CONTAINER (the_box), box_01);
    gtk_container_add (GTK_CONTAINER (the_box), box_02); 
    gtk_container_add (GTK_CONTAINER (the_box), box_03);

    gtk_box_pack_start(GTK_BOX (box_01), button_01,FALSE,FALSE,1); //close
    gtk_box_pack_start(GTK_BOX (box_01), button_03,FALSE,FALSE,1); //report
    gtk_box_pack_start(GTK_BOX (box_01), button_04,FALSE,FALSE,1); //report
    gtk_box_pack_start(GTK_BOX (box_01), button_05,FALSE,FALSE,1); //report

    gtk_box_pack_start(GTK_BOX(box_02),file_label,FALSE,FALSE,1); // label

    if(show_head==1){
         gtk_box_pack_start(GTK_BOX(box_03),linelabel,FALSE,FALSE,0);
         gtk_box_pack_start(GTK_BOX(box_03),hlabel1,FALSE,FALSE,0);
         gtk_box_pack_start(GTK_BOX(box_03),hlabel2,FALSE,FALSE,0);
         gtk_box_pack_start(GTK_BOX(box_03),hlabel3,FALSE,FALSE,0);
         gtk_box_pack_start(GTK_BOX(box_03),hlabel4,FALSE,FALSE,0);
         gtk_box_pack_start(GTK_BOX(box_03),hlabel5,FALSE,FALSE,0);    
    }
    
    gtk_widget_show(the_box);
    gtk_widget_show(box_01);
    gtk_widget_show(box_02);
    gtk_widget_show(box_03);

    gtk_widget_show (button_01);
    gtk_widget_show (button_03);
    gtk_widget_show (button_04);
    gtk_widget_show (button_05);
    gtk_widget_show (bbox1);
    gtk_widget_show (bbox3);
    gtk_widget_show (bbox4);
    gtk_widget_show (bbox5);

    gtk_widget_show (file_label);

    if(show_head==1){
       gtk_widget_show(linelabel);
       gtk_widget_show(hlabel1);
       gtk_widget_show(hlabel2);
       gtk_widget_show(hlabel3);
       gtk_widget_show(hlabel4);
       gtk_widget_show(hlabel5);
    }


    gtk_widget_show (window);
    gtk_main ();
    return 0;
}

 
