///////////////////////////////////////////////////
/// GTK GEDCOM List
/// 0.0.1 Initial Release
/// 0.0.2 Title change
///       Close Button Added
///       last action tags for
///          BIRT= birthdate
///          DEAT= deathdate
///          CHAN= changed
/// 0.1.0 individuals 500
///       Color coded
/// 0.1.1 HTML Report button
///       Show INDI numbers
///
/// Written By Michael Gibson under the GPL
/// (c) 2003
//////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

GtkWidget *button_01,*button_02, *button_02b, *button_03,*button_04;
GtkWidget *window, *the_box, *box_01, *box_02; 
GtkWidget *namelist[500];
GtkRcStyle *HighLight;
GdkColor color;
char *r_version="0.1.1";
int selectrow=0;
void print_report(void);
int indi;
char last_action[5];
char filename[50];
gchar indi_name[200];
int number_of_names=0;
int x=0;
char temp[200];
FILE *fp;


void showdata(void){
  char systemstring[50];
  sprintf(systemstring,"echo 'indidata %s %d' &",filename,selectrow);
  system(systemstring);
}

////////////////////////////////////
//// load report module
///////////////////////////////////
void l_report(void){
   char systemstring[50];
   sprintf(systemstring,"./gtkgedreport %s &",filename);
   system(systemstring);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy( GtkWidget *widget, gpointer   data )
{
    gtk_main_quit ();
}

//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{
 
GtkWidget *bbox1,*bbox2,*bbox2b,*bbox3,*bbox4,*image,*label,*scrolled_window;
 
  if(argc==2){ 
    sprintf(filename,"%s",argv[1]); }
  else{ 
    printf("No filename specified\n");
    exit(0);
  }
  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM list: Sorry, no file found. \n");
     exit(0);
  }
                                                                                                                             
  gtk_init (&argc, &argv);
                                                                                                                             
  /* create a new window */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_rc_parse("gedtools.rc" );
  gtk_window_set_title (GTK_WINDOW (window), "GTK GEDCOM List");
  gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
  gtk_window_set_default_size(GTK_WINDOW (window), 400,350);

  the_box = gtk_vbox_new (FALSE, 5);

  box_01 = gtk_hbutton_box_new();

    button_01 = gtk_button_new();
    bbox1 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (bbox1), 1);
    image = gtk_image_new_from_file ("close.xpm");
    label = gtk_label_new ("Close");
    gtk_box_pack_start (GTK_BOX (bbox1), image, FALSE, FALSE, 1);
    gtk_box_pack_start (GTK_BOX (bbox1), label, FALSE, FALSE, 1);
    gtk_widget_show (image);
    gtk_widget_show (label);
    gtk_container_add (GTK_CONTAINER (button_01), bbox1);

    button_02 = gtk_button_new();
    bbox2 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (bbox2), 1);
    image = gtk_image_new_from_file ("list.xpm");
    label = gtk_label_new ("List by Data");
    gtk_box_pack_start (GTK_BOX (bbox2), image, FALSE, FALSE, 1);
    gtk_box_pack_start (GTK_BOX (bbox2), label, FALSE, FALSE, 1);
    gtk_widget_show (image);
    gtk_widget_show (label);
    gtk_container_add (GTK_CONTAINER (button_02), bbox2);
 
    button_02b = gtk_button_new();
    bbox2b = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (bbox2b), 1);
    image = gtk_image_new_from_file ("list.xpm");
    label = gtk_label_new ("List by Surname");
    gtk_box_pack_start (GTK_BOX (bbox2b), image, FALSE, FALSE, 1);
    gtk_box_pack_start (GTK_BOX (bbox2b), label, FALSE, FALSE, 1);
    gtk_widget_show (image);
    gtk_widget_show (label);
    gtk_container_add (GTK_CONTAINER (button_02b), bbox2b);


    button_03 = gtk_button_new();
    bbox3 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (bbox2), 1);
    image = gtk_image_new_from_file ("hnew.xpm");
    label = gtk_label_new ("Create HTML");
    gtk_box_pack_start (GTK_BOX (bbox3), image, FALSE, FALSE, 1);
    gtk_box_pack_start (GTK_BOX (bbox3), label, FALSE, FALSE, 1);
    gtk_widget_show (image);
    gtk_widget_show (label);
    gtk_container_add (GTK_CONTAINER (button_03), bbox3);

    button_04 = gtk_button_new();
    bbox4 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (bbox4), 1);
    image = gtk_image_new_from_file ("viewi.xpm");
    label = gtk_label_new ("View Person");
    gtk_box_pack_start (GTK_BOX (bbox4), image, FALSE, FALSE, 1);
    gtk_box_pack_start (GTK_BOX (bbox4), label, FALSE, FALSE, 1);
    gtk_widget_show (image);
    gtk_widget_show (label);
    gtk_container_add (GTK_CONTAINER (button_04), bbox4);



/// Quit button call back
    g_signal_connect (G_OBJECT (button_01), "clicked", G_CALLBACK (destroy), NULL);
    g_signal_connect_swapped (G_OBJECT (button_01), "clicked", G_CALLBACK (gtk_widget_destroy), G_OBJECT (window));
                                                                                                                                              
/// New button call back
    g_signal_connect (G_OBJECT (button_02), "clicked", G_CALLBACK (print_report), NULL);

/// New button call back
    g_signal_connect (G_OBJECT (button_03), "clicked", G_CALLBACK (l_report), NULL);

/// 
    g_signal_connect (G_OBJECT (button_04), "clicked", G_CALLBACK (showdata), NULL);


    gtk_box_pack_start(GTK_BOX (box_01), button_01,FALSE,FALSE,5); //close
    gtk_box_pack_start(GTK_BOX (box_01), button_02,FALSE,FALSE,5); //list
    gtk_box_pack_start(GTK_BOX (box_01), button_02b,FALSE,FALSE,5); //list
    gtk_box_pack_start(GTK_BOX (box_01), button_03,FALSE,FALSE,5);
    gtk_box_pack_start(GTK_BOX (box_01), button_04,FALSE,FALSE,5);

  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
    gtk_widget_set_size_request (scrolled_window, 400, 500);

  box_02 = gtk_vbox_new (FALSE, 0);
    gtk_widget_set_size_request (scrolled_window, 400, 500);

    for(x=0;x<=500;x++){
      namelist[x] = gtk_entry_new();
      gtk_box_pack_start(box_02,namelist[x],FALSE,FALSE,0);
      gtk_editable_set_editable(GTK_ENTRY(namelist[x]),FALSE);
      gtk_entry_set_width_chars(GTK_ENTRY(namelist[x]),60);
      g_signal_connect (G_OBJECT (namelist[x]), "activate", G_CALLBACK (selectrow=indi), NULL);
    }

    gtk_container_add (GTK_CONTAINER (window), the_box);
    gtk_container_add (GTK_CONTAINER (the_box), box_01);
    gtk_container_add (GTK_CONTAINER (the_box), scrolled_window);
    //gtk_container_add (GTK_CONTAINER (scrolled_window), box_02);
    gtk_scrolled_window_add_with_viewport(scrolled_window,box_02);

  gtk_widget_show(button_01);
  gtk_widget_show(bbox1);
  gtk_widget_show(button_02);
  gtk_widget_show(bbox2);
  gtk_widget_show(button_02b);
  gtk_widget_show(bbox2b);
  gtk_widget_show(button_03);
  gtk_widget_show(bbox3);
  gtk_widget_show(button_04);
  gtk_widget_show(bbox4);
  gtk_widget_show(the_box);
  gtk_widget_show(box_01);
  gtk_widget_show(scrolled_window);
  gtk_widget_show(box_02);
  gtk_widget_show(window);
  gtk_main ();
  return(0);
}


//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{
     number_of_names=-1;

do{
  fgets(temp,80,fp);

    for(x=0;x<50;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      indi=atoi(temp);
  }



  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     number_of_names++;
     gtk_widget_show(namelist[number_of_names]);
     for(x=7;x<80;x++){temp[x-7]=temp[x];} 
     if(indi >=1){
        sprintf(indi_name,"%04d %s",indi,temp);
     }
     else{
        sprintf(indi_name,"Submitted by: %s",temp);
     }
 
     gtk_entry_set_text(GTK_ENTRY(namelist[number_of_names]),indi_name);
     gtk_entry_set_has_frame(GTK_ENTRY(namelist[number_of_names]),FALSE);
  }


  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){   ///2 DATE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}

     if(last_action[0]=='B' && last_action[1]=='I'){
       sprintf(indi_name, "%s (%s -",indi_name,temp);
       gtk_entry_set_text(GTK_ENTRY(namelist[number_of_names]),indi_name);
       color.red =   44110;
       color.blue =  44110;
       color.green = 65535;
       gtk_widget_modify_base(GTK_ENTRY(namelist[number_of_names]),GTK_STATE_NORMAL,&color);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       sprintf(indi_name, "%s %s)",indi_name,temp);
       gtk_entry_set_text(GTK_ENTRY(namelist[number_of_names]),indi_name);
       color.red =   65535;
       color.blue =      0;
       color.green = 65535;
       gtk_widget_modify_base(GTK_ENTRY(namelist[number_of_names]),GTK_STATE_NORMAL,&color);
     }

  }


  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
  }
                                                                                                                             
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H'){ //1 CHAN
     strcpy(last_action,"CHAN");

  }

}while(temp[0] !='0' || temp[2] !='T');

fclose(fp);

}
